package hitsdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// DescribeHiTSDBInstanceSecurityIpList invokes the hitsdb.DescribeHiTSDBInstanceSecurityIpList API synchronously
func (client *Client) DescribeHiTSDBInstanceSecurityIpList(request *DescribeHiTSDBInstanceSecurityIpListRequest) (response *DescribeHiTSDBInstanceSecurityIpListResponse, err error) {
	response = CreateDescribeHiTSDBInstanceSecurityIpListResponse()
	err = client.DoAction(request, response)
	return
}

// DescribeHiTSDBInstanceSecurityIpListWithChan invokes the hitsdb.DescribeHiTSDBInstanceSecurityIpList API asynchronously
func (client *Client) DescribeHiTSDBInstanceSecurityIpListWithChan(request *DescribeHiTSDBInstanceSecurityIpListRequest) (<-chan *DescribeHiTSDBInstanceSecurityIpListResponse, <-chan error) {
	responseChan := make(chan *DescribeHiTSDBInstanceSecurityIpListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.DescribeHiTSDBInstanceSecurityIpList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// DescribeHiTSDBInstanceSecurityIpListWithCallback invokes the hitsdb.DescribeHiTSDBInstanceSecurityIpList API asynchronously
func (client *Client) DescribeHiTSDBInstanceSecurityIpListWithCallback(request *DescribeHiTSDBInstanceSecurityIpListRequest, callback func(response *DescribeHiTSDBInstanceSecurityIpListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *DescribeHiTSDBInstanceSecurityIpListResponse
		var err error
		defer close(result)
		response, err = client.DescribeHiTSDBInstanceSecurityIpList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// DescribeHiTSDBInstanceSecurityIpListRequest is the request struct for api DescribeHiTSDBInstanceSecurityIpList
type DescribeHiTSDBInstanceSecurityIpListRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	GroupName            string           `position:"Query" name:"GroupName"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
}

// DescribeHiTSDBInstanceSecurityIpListResponse is the response struct for api DescribeHiTSDBInstanceSecurityIpList
type DescribeHiTSDBInstanceSecurityIpListResponse struct {
	*responses.BaseResponse
	RequestId      string       `json:"RequestId" xml:"RequestId"`
	SecurityIpList []SecurityIp `json:"SecurityIpList" xml:"SecurityIpList"`
}

// CreateDescribeHiTSDBInstanceSecurityIpListRequest creates a request to invoke DescribeHiTSDBInstanceSecurityIpList API
func CreateDescribeHiTSDBInstanceSecurityIpListRequest() (request *DescribeHiTSDBInstanceSecurityIpListRequest) {
	request = &DescribeHiTSDBInstanceSecurityIpListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("hitsdb", "2017-06-01", "DescribeHiTSDBInstanceSecurityIpList", "hitsdb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateDescribeHiTSDBInstanceSecurityIpListResponse creates a response to parse from DescribeHiTSDBInstanceSecurityIpList response
func CreateDescribeHiTSDBInstanceSecurityIpListResponse() (response *DescribeHiTSDBInstanceSecurityIpListResponse) {
	response = &DescribeHiTSDBInstanceSecurityIpListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
