package hitsdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyHiTSDBInstanceClass invokes the hitsdb.ModifyHiTSDBInstanceClass API synchronously
func (client *Client) ModifyHiTSDBInstanceClass(request *ModifyHiTSDBInstanceClassRequest) (response *ModifyHiTSDBInstanceClassResponse, err error) {
	response = CreateModifyHiTSDBInstanceClassResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyHiTSDBInstanceClassWithChan invokes the hitsdb.ModifyHiTSDBInstanceClass API asynchronously
func (client *Client) ModifyHiTSDBInstanceClassWithChan(request *ModifyHiTSDBInstanceClassRequest) (<-chan *ModifyHiTSDBInstanceClassResponse, <-chan error) {
	responseChan := make(chan *ModifyHiTSDBInstanceClassResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyHiTSDBInstanceClass(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyHiTSDBInstanceClassWithCallback invokes the hitsdb.ModifyHiTSDBInstanceClass API asynchronously
func (client *Client) ModifyHiTSDBInstanceClassWithCallback(request *ModifyHiTSDBInstanceClassRequest, callback func(response *ModifyHiTSDBInstanceClassResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyHiTSDBInstanceClassResponse
		var err error
		defer close(result)
		response, err = client.ModifyHiTSDBInstanceClass(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyHiTSDBInstanceClassRequest is the request struct for api ModifyHiTSDBInstanceClass
type ModifyHiTSDBInstanceClassRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	InstanceClass        string           `position:"Query" name:"InstanceClass"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	InstanceStorage      string           `position:"Query" name:"InstanceStorage"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
	AppKey               string           `position:"Query" name:"AppKey"`
}

// ModifyHiTSDBInstanceClassResponse is the response struct for api ModifyHiTSDBInstanceClass
type ModifyHiTSDBInstanceClassResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyHiTSDBInstanceClassRequest creates a request to invoke ModifyHiTSDBInstanceClass API
func CreateModifyHiTSDBInstanceClassRequest() (request *ModifyHiTSDBInstanceClassRequest) {
	request = &ModifyHiTSDBInstanceClassRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("hitsdb", "2017-06-01", "ModifyHiTSDBInstanceClass", "hitsdb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyHiTSDBInstanceClassResponse creates a response to parse from ModifyHiTSDBInstanceClass response
func CreateModifyHiTSDBInstanceClassResponse() (response *ModifyHiTSDBInstanceClassResponse) {
	response = &ModifyHiTSDBInstanceClassResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
