package hitsdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// ModifyHiTSDBInstanceSecurityIpList invokes the hitsdb.ModifyHiTSDBInstanceSecurityIpList API synchronously
func (client *Client) ModifyHiTSDBInstanceSecurityIpList(request *ModifyHiTSDBInstanceSecurityIpListRequest) (response *ModifyHiTSDBInstanceSecurityIpListResponse, err error) {
	response = CreateModifyHiTSDBInstanceSecurityIpListResponse()
	err = client.DoAction(request, response)
	return
}

// ModifyHiTSDBInstanceSecurityIpListWithChan invokes the hitsdb.ModifyHiTSDBInstanceSecurityIpList API asynchronously
func (client *Client) ModifyHiTSDBInstanceSecurityIpListWithChan(request *ModifyHiTSDBInstanceSecurityIpListRequest) (<-chan *ModifyHiTSDBInstanceSecurityIpListResponse, <-chan error) {
	responseChan := make(chan *ModifyHiTSDBInstanceSecurityIpListResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.ModifyHiTSDBInstanceSecurityIpList(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// ModifyHiTSDBInstanceSecurityIpListWithCallback invokes the hitsdb.ModifyHiTSDBInstanceSecurityIpList API asynchronously
func (client *Client) ModifyHiTSDBInstanceSecurityIpListWithCallback(request *ModifyHiTSDBInstanceSecurityIpListRequest, callback func(response *ModifyHiTSDBInstanceSecurityIpListResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *ModifyHiTSDBInstanceSecurityIpListResponse
		var err error
		defer close(result)
		response, err = client.ModifyHiTSDBInstanceSecurityIpList(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// ModifyHiTSDBInstanceSecurityIpListRequest is the request struct for api ModifyHiTSDBInstanceSecurityIpList
type ModifyHiTSDBInstanceSecurityIpListRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	GroupName            string           `position:"Query" name:"GroupName"`
	SecurityIpList       string           `position:"Query" name:"SecurityIpList"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
}

// ModifyHiTSDBInstanceSecurityIpListResponse is the response struct for api ModifyHiTSDBInstanceSecurityIpList
type ModifyHiTSDBInstanceSecurityIpListResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateModifyHiTSDBInstanceSecurityIpListRequest creates a request to invoke ModifyHiTSDBInstanceSecurityIpList API
func CreateModifyHiTSDBInstanceSecurityIpListRequest() (request *ModifyHiTSDBInstanceSecurityIpListRequest) {
	request = &ModifyHiTSDBInstanceSecurityIpListRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("hitsdb", "2017-06-01", "ModifyHiTSDBInstanceSecurityIpList", "hitsdb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateModifyHiTSDBInstanceSecurityIpListResponse creates a response to parse from ModifyHiTSDBInstanceSecurityIpList response
func CreateModifyHiTSDBInstanceSecurityIpListResponse() (response *ModifyHiTSDBInstanceSecurityIpListResponse) {
	response = &ModifyHiTSDBInstanceSecurityIpListResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
