package hitsdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RenameHiTSDBInstanceAlias invokes the hitsdb.RenameHiTSDBInstanceAlias API synchronously
func (client *Client) RenameHiTSDBInstanceAlias(request *RenameHiTSDBInstanceAliasRequest) (response *RenameHiTSDBInstanceAliasResponse, err error) {
	response = CreateRenameHiTSDBInstanceAliasResponse()
	err = client.DoAction(request, response)
	return
}

// RenameHiTSDBInstanceAliasWithChan invokes the hitsdb.RenameHiTSDBInstanceAlias API asynchronously
func (client *Client) RenameHiTSDBInstanceAliasWithChan(request *RenameHiTSDBInstanceAliasRequest) (<-chan *RenameHiTSDBInstanceAliasResponse, <-chan error) {
	responseChan := make(chan *RenameHiTSDBInstanceAliasResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RenameHiTSDBInstanceAlias(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RenameHiTSDBInstanceAliasWithCallback invokes the hitsdb.RenameHiTSDBInstanceAlias API asynchronously
func (client *Client) RenameHiTSDBInstanceAliasWithCallback(request *RenameHiTSDBInstanceAliasRequest, callback func(response *RenameHiTSDBInstanceAliasResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RenameHiTSDBInstanceAliasResponse
		var err error
		defer close(result)
		response, err = client.RenameHiTSDBInstanceAlias(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RenameHiTSDBInstanceAliasRequest is the request struct for api RenameHiTSDBInstanceAlias
type RenameHiTSDBInstanceAliasRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	InstanceAlias        string           `position:"Query" name:"InstanceAlias"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
	AppKey               string           `position:"Query" name:"AppKey"`
}

// RenameHiTSDBInstanceAliasResponse is the response struct for api RenameHiTSDBInstanceAlias
type RenameHiTSDBInstanceAliasResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRenameHiTSDBInstanceAliasRequest creates a request to invoke RenameHiTSDBInstanceAlias API
func CreateRenameHiTSDBInstanceAliasRequest() (request *RenameHiTSDBInstanceAliasRequest) {
	request = &RenameHiTSDBInstanceAliasRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("hitsdb", "2017-06-01", "RenameHiTSDBInstanceAlias", "hitsdb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRenameHiTSDBInstanceAliasResponse creates a response to parse from RenameHiTSDBInstanceAlias response
func CreateRenameHiTSDBInstanceAliasResponse() (response *RenameHiTSDBInstanceAliasResponse) {
	response = &RenameHiTSDBInstanceAliasResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
