package hitsdb

//Licensed under the Apache License, Version 2.0 (the "License");
//you may not use this file except in compliance with the License.
//You may obtain a copy of the License at
//
//http://www.apache.org/licenses/LICENSE-2.0
//
//Unless required by applicable law or agreed to in writing, software
//distributed under the License is distributed on an "AS IS" BASIS,
//WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
//See the License for the specific language governing permissions and
//limitations under the License.
//
// Code generated by Alibaba Cloud SDK Code Generator.
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

import (
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/requests"
	"github.com/aliyun/alibaba-cloud-sdk-go/sdk/responses"
)

// RestartHiTSDBInstance invokes the hitsdb.RestartHiTSDBInstance API synchronously
func (client *Client) RestartHiTSDBInstance(request *RestartHiTSDBInstanceRequest) (response *RestartHiTSDBInstanceResponse, err error) {
	response = CreateRestartHiTSDBInstanceResponse()
	err = client.DoAction(request, response)
	return
}

// RestartHiTSDBInstanceWithChan invokes the hitsdb.RestartHiTSDBInstance API asynchronously
func (client *Client) RestartHiTSDBInstanceWithChan(request *RestartHiTSDBInstanceRequest) (<-chan *RestartHiTSDBInstanceResponse, <-chan error) {
	responseChan := make(chan *RestartHiTSDBInstanceResponse, 1)
	errChan := make(chan error, 1)
	err := client.AddAsyncTask(func() {
		defer close(responseChan)
		defer close(errChan)
		response, err := client.RestartHiTSDBInstance(request)
		if err != nil {
			errChan <- err
		} else {
			responseChan <- response
		}
	})
	if err != nil {
		errChan <- err
		close(responseChan)
		close(errChan)
	}
	return responseChan, errChan
}

// RestartHiTSDBInstanceWithCallback invokes the hitsdb.RestartHiTSDBInstance API asynchronously
func (client *Client) RestartHiTSDBInstanceWithCallback(request *RestartHiTSDBInstanceRequest, callback func(response *RestartHiTSDBInstanceResponse, err error)) <-chan int {
	result := make(chan int, 1)
	err := client.AddAsyncTask(func() {
		var response *RestartHiTSDBInstanceResponse
		var err error
		defer close(result)
		response, err = client.RestartHiTSDBInstance(request)
		callback(response, err)
		result <- 1
	})
	if err != nil {
		defer close(result)
		callback(nil, err)
		result <- 0
	}
	return result
}

// RestartHiTSDBInstanceRequest is the request struct for api RestartHiTSDBInstance
type RestartHiTSDBInstanceRequest struct {
	*requests.RpcRequest
	ResourceOwnerId      requests.Integer `position:"Query" name:"ResourceOwnerId"`
	SecurityToken        string           `position:"Query" name:"SecurityToken"`
	ResourceOwnerAccount string           `position:"Query" name:"ResourceOwnerAccount"`
	OwnerAccount         string           `position:"Query" name:"OwnerAccount"`
	OwnerId              requests.Integer `position:"Query" name:"OwnerId"`
	InstanceId           string           `position:"Query" name:"InstanceId"`
}

// RestartHiTSDBInstanceResponse is the response struct for api RestartHiTSDBInstance
type RestartHiTSDBInstanceResponse struct {
	*responses.BaseResponse
	RequestId string `json:"RequestId" xml:"RequestId"`
}

// CreateRestartHiTSDBInstanceRequest creates a request to invoke RestartHiTSDBInstance API
func CreateRestartHiTSDBInstanceRequest() (request *RestartHiTSDBInstanceRequest) {
	request = &RestartHiTSDBInstanceRequest{
		RpcRequest: &requests.RpcRequest{},
	}
	request.InitWithApiInfo("hitsdb", "2017-06-01", "RestartHiTSDBInstance", "hitsdb", "openAPI")
	request.Method = requests.POST
	return
}

// CreateRestartHiTSDBInstanceResponse creates a response to parse from RestartHiTSDBInstance response
func CreateRestartHiTSDBInstanceResponse() (response *RestartHiTSDBInstanceResponse) {
	response = &RestartHiTSDBInstanceResponse{
		BaseResponse: &responses.BaseResponse{},
	}
	return
}
